#include <stdio.h>
#include "makebin.h"
#include "make9xz.h"

#define ROMCALL 0
#define VALUE 1
#define OTHERLIB 2
#define UNDEFINED -1

unsigned char objheader[0x18]={0,0,3,0xe7,0,0,0,0,0,0,3,0xe8,0,0,0,1,0x20,0,
        0,0,0,0,3,0xe9};
unsigned char code[65536];
int codelen;
int relofs[16384];
int relcount;
int bssrelofs[16384];
int bssrelcount;
int bsssize;
char libname[32][9];
int librelofs[32][4096];
int librelnum[32][4096];
int librelcount[32];
int libcount;
int library;
int error=0;

struct
{
        char *name;
        int type;
        int num;
        char *symname;
} tiosFunc[]={{"tios::ST_eraseHelp",ROMCALL,0xe3,NULL},
            {"tios::ST_showHelp",ROMCALL,0xe6,NULL},
            {"tios::HeapFree",ROMCALL,0x97,NULL},
            {"tios::HeapAlloc",ROMCALL,0x90,NULL},
            {"tios::ER_catch",ROMCALL,0x154,NULL},
            {"tios::ER_success",ROMCALL,0x155,NULL},
            {"tios::reset_link",ROMCALL,0x24c,NULL},
            {"tios::flush_link",ROMCALL,0x24d,NULL},
            {"tios::tx_free",ROMCALL,0x252,NULL},
            {"tios::transmit",ROMCALL,0x250,NULL},
            {"tios::receive",ROMCALL,0x24f,NULL},
            {"tios::HeapFreeIndir",ROMCALL,0x98,NULL},
            {"tios::ST_busy",ROMCALL,0xe2,NULL},
            {"tios::ER_throwVar",ROMCALL,0x153,NULL},
            {"tios::HeapRealloc",ROMCALL,0x9d,NULL},
            {"tios::sprintf",ROMCALL,0x53,NULL},
            {"tios::DrawStrXY",ROMCALL,0x1a9,NULL},
            {"tios::DrawCharXY",OTHERLIB,0,"util@000D"},
            {"tios::FontSetSys",ROMCALL,0x18f,NULL},
            {"tios::DrawTo",ROMCALL,0x19c,NULL},
            {"tios::MoveTo",ROMCALL,0x19d,NULL},
            {"tios::PortSet",ROMCALL,0x1a2,NULL},
            {"tios::PortRestore",ROMCALL,0x1a3,NULL},
            {"tios::WinActivate",ROMCALL,0x1,NULL},
            {"tios::WinClose",ROMCALL,0xb,NULL},
            {"tios::WinOpen",ROMCALL,0x1e,NULL},
            {"tios::WinStrXY",ROMCALL,0x26,NULL},
            {"tios::kb_globals",VALUE,0x757c,NULL},
            {"tios::globals",VALUE,0x4c00,NULL},
            {"tios::ST_flags",UNDEFINED,0,NULL},
            {"tios::MenuPopup",ROMCALL,0x3b,NULL},
            {"tios::MenuBegin",ROMCALL,0x36,NULL},
            {"tios::MenuOn",ROMCALL,0x3a,NULL},
            {"tios::SF_font",OTHERLIB,0,"util@0013"},
            {"tios::HeapAllocThrow",ROMCALL,0x93,NULL},
            {"tios::strcmp",ROMCALL,0x271,NULL},
            {"tios::FindSymEntry",OTHERLIB,0,"util@000F"},
            {"tios::ROM_base",VALUE,0x400000,NULL},
            {"tios::FontGetSys",ROMCALL,0x18e,NULL},
            {"tios::vcbprintf",UNDEFINED,0,NULL},
            {"tios::strlen",ROMCALL,0x27e,NULL},
            {"tios::strncmp",ROMCALL,0x272,NULL},
            {"tios::strncpy",ROMCALL,0x26d,NULL},
            {"tios::strcat",ROMCALL,0x26e,NULL},
            {"tios::strchr",ROMCALL,0x274,NULL},
            {"tios::push_quantum",UNDEFINED,0,NULL},
            {"tios::OSAlexOut",UNDEFINED,0,NULL},
            {"tios::ERD_dialog",ROMCALL,0x151,NULL},
            {"tios::check_estack_size",UNDEFINED,0,NULL},
            {"tios::labs",UNDEFINED,0,NULL},
            {"tios::memset",ROMCALL,0x27c,NULL},
            {"tios::memcmp",ROMCALL,0x270,NULL},
            {"tios::memcpy",ROMCALL,0x26a,NULL},
            {"tios::memmove",ROMCALL,0x26b,NULL},
            {"tios::abs",UNDEFINED,0,NULL},
            {"tios::rand",UNDEFINED,0,NULL},
            {"tios::srand",UNDEFINED,0,NULL},
            {"tios::_du32u32",ROMCALL,0x2aa,NULL},
            {"tios::_ds32s32",ROMCALL,0x2a8,NULL},
            {"tios::_du16u16",ROMCALL,0x2a6,NULL},
            {"tios::_ds16u16",ROMCALL,0x2a4,NULL},
            {"tios::_ru32u32",ROMCALL,0x2ab,NULL},
            {"tios::_rs32s32",ROMCALL,0x2a9,NULL},
            {"tios::_ru16u16",ROMCALL,0x2a7,NULL},
            {"tios::_rs16u16",ROMCALL,0x2a5,NULL},
            {"tios::DerefSym",ROMCALL,0x79,NULL}};

struct
{
        char *name;
        int type;
        int num;
        char *symname;
} flibFunc[]={{"flib::find_pixel",ROMCALL,0,NULL},
            {"flib::pixel_on",ROMCALL,1,NULL},
            {"flib::pixel_off",ROMCALL,2,NULL},
            {"flib::pixel_chg",ROMCALL,3,NULL},
            {"flib::prep_rect",ROMCALL,4,NULL},
            {"flib::frame_rect",ROMCALL,5,NULL},
            {"flib::erase_rect",ROMCALL,6,NULL},
            {"flib::show_dialog",ROMCALL,7,NULL},
            {"flib::clear_dialog",ROMCALL,8,NULL},
            {"flib::clr_scr",ROMCALL,9,NULL},
            {"flib::zap_screen",ROMCALL,0xa,NULL},
            {"flib::idle_loop",ROMCALL,0xb,NULL},
            {"flib::random",ROMCALL,0xc,NULL},
            {"flib::rand_seed",ROMCALL,0x10,NULL}};

struct
{
        char *name;
        int type;
        int num;
        char *symname;
} kernelFunc[]={{"kernel::exec",OTHERLIB,0,"util@000E"}};

struct
{
        char *name;
        int type;
        int num;
        char *symname;
} gray4libFunc[]={{"gray4lib::on",ROMCALL,1,NULL},
                  {"gray4lib::off",ROMCALL,0,NULL},
                  {"gray4lib::plane0",ROMCALL,2,NULL},
                  {"gray4lib::plane1",ROMCALL,3,NULL}};

int ReadWord(FILE *fp)
{
        int n;

        n=fgetc(fp)<<8;
        n|=fgetc(fp);
        return n;
}

void ReadString(FILE *fp,char *str)
{
        int i,v;

        for (i=0;;i++)
        {
                v=fgetc(fp);
                str[i]=v;
                if (v==0) break;
        }
}

void WriteDWord(FILE *fp,int n)
{
        fputc((n>>24)&0xff,fp);
        fputc((n>>16)&0xff,fp);
        fputc((n>>8)&0xff,fp);
        fputc(n&0xff,fp);
}

void WriteNString(FILE *fp,char *str,int n)
{
        int i,l;

        l=strlen(str);
        for (i=0;i<n;i++)
        {
                if (i<l) fputc(str[i],fp);
                else fputc(0,fp);
        }
}

void AddDWord(int ofs,int n)
{
        int v;

        v=code[ofs]<<24;
        v|=code[ofs+1]<<16;
        v|=code[ofs+2]<<8;
        v|=code[ofs+3];
        v+=n;
        code[ofs]=(v>>24)&0xff;
        code[ofs+1]=(v>>16)&0xff;
        code[ofs+2]=(v>>8)&0xff;
        code[ofs+3]=v&0xff;
}

void SetDWord(int ofs,int n)
{
        code[ofs]=(n>>24)&0xff;
        code[ofs+1]=(n>>16)&0xff;
        code[ofs+2]=(n>>8)&0xff;
        code[ofs+3]=n&0xff;
}

void AddLibRef(int ln,int ofs,int num)
{
        if (!strcmp(libname[ln],"tios"))
        {
                if (tiosFunc[num].type==UNDEFINED)
                {
                        int v;
                        v=code[ofs]<<24;
                        v|=code[ofs+1]<<16;
                        v|=code[ofs+2]<<8;
                        v|=code[ofs+3];
                        if (v==0)
                                printf("Symbol %s not defined in PlusShell\n",tiosFunc[num].name);
                        else
                                printf("Symbol %s+$%X not defined in PlusShell\n",tiosFunc[num].name,v);
                        error=1;
                }
                else if (tiosFunc[num].type==VALUE)
                {
                        int v;
                        v=code[ofs]<<24;
                        v|=code[ofs+1]<<16;
                        v|=code[ofs+2]<<8;
                        v|=code[ofs+3];
                        if ((num==0x1b)&&(v==0x1c))
                                SetDWord(ofs,0x75bc);
                        else if ((num==0x1b)&&(v==0xc))
                                SetDWord(ofs,0x75a2);
                        else if ((num==0x1b)&&(v==-6))
                                SetDWord(ofs,0x75be);
                        else if ((num==0x1b)&&(v!=0x1e))
                                printf("Symbol tios::kb_globals+$%X not defined in PlusShell\n",v);
                        else if ((num==0x1c)&&(v<3840)) // tios::main_lcd
                                AddDWord(ofs,0x4c00);
                        else if ((num==0x1c)&&(v==0x1902)) // tios::Heap
                                SetDWord(ofs,0x7592);
                        else if ((num==0x1c)&&(v!=0x194c)&&(v!=0x1950))
                                printf("Symbol tios::globals+$%X not defined in PlusShell\n",v);
                        else
                                AddDWord(ofs,tiosFunc[num].num);
                        v=code[ofs]<<24;
                        v|=code[ofs+1]<<16;
                        v|=code[ofs+2]<<8;
                        v|=code[ofs+3];
                }
                else
                {
                        librelofs[ln][librelcount[ln]]=ofs;
                        librelnum[ln][librelcount[ln]++]=num;
                }
        }
        else if (!strcmp(libname[ln],"flib"))
        {
                if (flibFunc[num].type==UNDEFINED)
                {
                        printf("Symbol %s not defined in PlusShell\n",flibFunc[num].name);
                        error=1;
                }
                else if (flibFunc[num].type==VALUE)
                        AddDWord(ofs,flibFunc[num].num);
                else
                {
                        librelofs[ln][librelcount[ln]]=ofs;
                        librelnum[ln][librelcount[ln]++]=num;
                }
        }
        else if (!strcmp(libname[ln],"kernel"))
        {
                if (kernelFunc[num].type==UNDEFINED)
                {
                        printf("Symbol %s not defined in PlusShell\n",kernelFunc[num].name);
                        error=1;
                }
                else if (kernelFunc[num].type==VALUE)
                        AddDWord(ofs,kernelFunc[num].num);
                else
                {
                        librelofs[ln][librelcount[ln]]=ofs;
                        librelnum[ln][librelcount[ln]++]=num;
                }
        }
        else
        {
                librelofs[ln][librelcount[ln]]=ofs;
                librelnum[ln][librelcount[ln]++]=num;
        }
}

int main(int argc,char *argv[])
{
        FILE *fp,*out;
        char str[256];
        int i,j,k,n,v,ofs,num,size;

        if (argc<2)
        {
                printf("Usage: CONVERT 92PFile (without extension)\n");
                return 1;
        }
        sprintf(str,"%s.92p",argv[1]);
        fp=fopen(str,"rb");
        if (fp==NULL)
        {
                printf("Error opening input file %s\n",str);
                return 1;
        }
        sprintf(str,"%s.o",argv[1]);
        out=fopen(str,"wb");
        for (i=0;i<0x18;i++)
                fputc(objheader[i],out);
        fseek(fp,0x5e,SEEK_SET);
        if (ReadWord(fp)==0x4150)
        {
                library=0;
                printf("Converting Fargo II program...\n");
        }
        else
        {
                library=1;
                printf("Converting Fargo II library...\n");
        }
        fseek(fp,0x6a,SEEK_SET);
        size=ReadWord(fp)-0x1a;
        size=(size+3)&(~3);
        WriteDWord(out,size>>2);
        fseek(fp,0x70,SEEK_SET);
        codelen=size;
        for (i=0;i<size;i++)
                code[i]=fgetc(fp);
        fseek(fp,0x64,SEEK_SET);
        fseek(fp,ReadWord(fp)+0x56,SEEK_SET);
        relcount=0;
        ofs=-6;
        while (1)
        {
                v=fgetc(fp);
                if (v==0) break;
                if (v<0x80)
                        ofs+=(v+1)<<1;
                else if (v<0xc0)
                {
                        ofs+=((v&0xf)+2)<<1;
                        i=(v>>4)-7;
                        for (;i;i--)
                        {
                                v=fgetc(fp);
                                relofs[relcount++]=ofs;
                                AddDWord(ofs,-0x1a);
                                ofs+=((v>>4)+2)<<1;
                                relofs[relcount++]=ofs;
                                AddDWord(ofs,-0x1a);
                                ofs+=((v&0xf)+2)<<1;
                        }
                }
                else
                {
                        v<<=8;
                        v|=fgetc(fp);
                        v&=0x3fff;
                        ofs+=(v+0x81)<<1;
                }
                relofs[relcount++]=ofs;
                AddDWord(ofs,-0x1a);
        }
        fseek(fp,0x66,SEEK_SET);
        fseek(fp,ReadWord(fp)+0x56,SEEK_SET);
        bsssize=ReadWord(fp);
        bssrelcount=0;
        ofs=-6;
        while (1)
        {
                v=fgetc(fp);
                if (v==0) break;
                if (v<0x80)
                        ofs+=(v+1)<<1;
                else if (v<0xc0)
                {
                        ofs+=((v&0xf)+2)<<1;
                        i=(v>>4)-7;
                        for (;i;i--)
                        {
                                v=fgetc(fp);
                                bssrelofs[bssrelcount++]=ofs;
                                ofs+=((v>>4)+2)<<1;
                                bssrelofs[bssrelcount++]=ofs;
                                ofs+=((v&0xf)+2)<<1;
                        }
                }
                else
                {
                        v<<=8;
                        v|=fgetc(fp);
                        v&=0x3fff;
                        ofs+=(v+0x81)<<1;
                }
                bssrelofs[bssrelcount++]=ofs;
        }
        fseek(fp,0x68,SEEK_SET);
        fseek(fp,ReadWord(fp)+0x56,SEEK_SET);
        libcount=ReadWord(fp);
        fseek(fp,ReadWord(fp)+0x56,SEEK_SET);
        for (i=0;i<libcount;i++)
                ReadString(fp,libname[i]);
        fseek(fp,0x68,SEEK_SET);
        fseek(fp,ReadWord(fp)+0x5a,SEEK_SET);
        for (i=0;i<libcount;i++)
        {
                librelcount[i]=0;
                num=-1;
                while (1)
                {
                        v=fgetc(fp);
                        if (v==0) break;
                        num+=v;
                        ofs=-6;
                        while (1)
                        {
                                v=fgetc(fp);
                                if (v==0) break;
                                if (v<0x80)
                                        ofs+=(v+1)<<1;
                                else if (v<0xc0)
                                {
                                        ofs+=((v&0xf)+2)<<1;
                                        j=(v>>4)-7;
                                        for (;j;j--)
                                        {
                                                v=fgetc(fp);
                                                AddLibRef(i,ofs,num);
                                                ofs+=((v>>4)+2)<<1;
                                                AddLibRef(i,ofs,num);
                                                ofs+=((v&0xf)+2)<<1;
                                        }
                                }
                                else
                                {
                                        v<<=8;
                                        v|=fgetc(fp);
                                        v&=0x3fff;
                                        ofs+=(v+0x81)<<1;
                                }
                                AddLibRef(i,ofs,num);
                        }
                }
        }
        for (i=0;i<codelen;i++)
                fputc(code[i],out);
        if ((relcount>0)||(bssrelcount>0))
        {
                WriteDWord(out,0x3ec);
                if (relcount>0)
                {
                        WriteDWord(out,relcount);
                        WriteDWord(out,0);
                        for (i=0;i<relcount;i++)
                                WriteDWord(out,relofs[i]);
                }
                if (bssrelcount>0)
                {
                        WriteDWord(out,bssrelcount);
                        WriteDWord(out,1);
                        for (i=0;i<bssrelcount;i++)
                                WriteDWord(out,bssrelofs[i]);
                }
                WriteDWord(out,0);
        }
        WriteDWord(out,0x3ef);
        if (!library)
        {
                WriteDWord(out,0x1000002);
                WriteNString(out,"_main",8);
                fseek(fp,0x6a,SEEK_SET);
                fseek(fp,ReadWord(fp)+0x58,SEEK_SET);
                WriteDWord(out,ReadWord(fp)-0x1a);
                WriteDWord(out,0x1000002);
                WriteNString(out,"_comment",8);
                fseek(fp,0x6c,SEEK_SET);
                WriteDWord(out,ReadWord(fp)-0x1a);
        }
        WriteDWord(out,0x1000004);
        WriteNString(out,"_FARGO_CONVERT",16);
        WriteDWord(out,0);
        if (library)
        {
                WriteDWord(out,0x1000002);
                WriteNString(out,"_library",8);
                WriteDWord(out,0);
                fseek(fp,0x6a,SEEK_SET);
                fseek(fp,ReadWord(fp)+0x56,SEEK_SET);
                n=ReadWord(fp);
                for (i=0;i<n;i++)
                {
                        WriteDWord(out,0x1000002);
                        sprintf(str,"fnc@%4.4X",i);
                        WriteNString(out,str,8);
                        WriteDWord(out,ReadWord(fp)-0x1a);
                }
        }
        for (i=0;i<libcount;i++)
        {
                for (j=0;j<librelcount[i];)
                {                        
                        sprintf(str,"%s@%4.4X",libname[i],librelnum[i][j]);
                        if (!strcmp(libname[i],"tios"))
                        {
                                int done=0;
                                if (librelnum[i][j]==0x1c)
                                {
                                        int v,ofs;
                                        ofs=librelofs[i][j];
                                        v=code[ofs]<<24;
                                        v|=code[ofs+1]<<16;
                                        v|=code[ofs+2]<<8;
                                        v|=code[ofs+3];
                                        if (v==0x194c)
                                        {
                                                strcpy(str,"util@0014");
                                                done=1;
                                        }
                                        else if (v==0x1950)
                                        {
                                                strcpy(str,"util@0015");
                                                done=1;
                                        }
                                }
                                if (!done)
                                {
                                        switch (tiosFunc[librelnum[i][j]].type)
                                        {
                                                case ROMCALL:
                                                        sprintf(str,"_ROM_CALL_%3.3X",tiosFunc[librelnum[i][j]].num);
                                                        break;
                                                case OTHERLIB:
                                                        strcpy(str,tiosFunc[librelnum[i][j]].symname);
                                                        break;
                                        }
                                }
                        }
                        else if (!strcmp(libname[i],"flib"))
                        {
                                switch (flibFunc[librelnum[i][j]].type)
                                {
                                        case ROMCALL:
                                                sprintf(str,"util@%4.4X",flibFunc[librelnum[i][j]].num);
                                                break;
                                        case OTHERLIB:
                                                strcpy(str,flibFunc[librelnum[i][j]].symname);
                                                break;
                                }
                        }
                        else if (!strcmp(libname[i],"kernel"))
                                strcpy(str,kernelFunc[librelnum[i][j]].symname);
                        else if (!strcmp(libname[i],"gray4lib"))
                                sprintf(str,"gray4lib@%4.4X",gray4libFunc[librelnum[i][j]].num);
                        WriteDWord(out,0x81000000|(((strlen(str)+3)&(~3))>>2));
                        WriteNString(out,str,(strlen(str)+3)&(~3));
                        n=1;
                        for (k=j+1;k<librelcount[i];k++)
                        {
                                if (librelnum[i][k]!=librelnum[i][j])
                                        break;
                                n++;
                        }
                        WriteDWord(out,n);
                        for (k=0;k<n;k++)
                                WriteDWord(out,librelofs[i][j++]);
                }
        }
        WriteDWord(out,0);
        WriteDWord(out,0x3f2);
        if (bsssize>0)
        {
                WriteDWord(out,0x3e8);
                WriteDWord(out,1);
                WriteDWord(out,0x20000000);
                WriteDWord(out,0x3eb);
                WriteDWord(out,(bsssize+3)>>2);
                WriteDWord(out,0x3f2);
        }
        fclose(fp);
        fclose(out);
        if (error) return error;
        if (makebin(argv[1])) return 1;
        if (make9xz(argv[1])) return 1;
        printf("Done!\n");
        return 0;
}

